diff -pruN 20190518.gitdbc8e35-1/debian/changelog 20200801.git2319892-1/debian/changelog
--- 20190518.gitdbc8e35-1/debian/changelog	2020-01-26 18:28:17.000000000 +0000
+++ 20200801.git2319892-1/debian/changelog	2020-12-08 13:19:55.000000000 +0000
@@ -1,3 +1,16 @@
+cl-trivial-garbage (20200801.git2319892-1) unstable; urgency=medium
+
+  [ Sébastien Villemot ]
+  * New upstream snapshot
+  * Bump to S-V 4.5.1
+  * Bump to debhelper 13
+  * Add more fields to d/upstream/metadata
+
+  [ Debian Janitor ]
+  * Set upstream metadata fields: Bug-Database, Bug-Submit.
+
+ -- Sébastien Villemot <sebastien@debian.org>  Tue, 08 Dec 2020 14:19:55 +0100
+
 cl-trivial-garbage (20190518.gitdbc8e35-1) unstable; urgency=medium
 
   * New upstream snapshot
diff -pruN 20190518.gitdbc8e35-1/debian/control 20200801.git2319892-1/debian/control
--- 20190518.gitdbc8e35-1/debian/control	2020-01-26 18:27:46.000000000 +0000
+++ 20200801.git2319892-1/debian/control	2020-12-08 13:16:51.000000000 +0000
@@ -3,8 +3,8 @@ Section: lisp
 Priority: optional
 Maintainer: Debian Common Lisp Team <debian-common-lisp@lists.debian.org>
 Uploaders: Sébastien Villemot <sebastien@debian.org>
-Build-Depends: debhelper-compat (= 12)
-Standards-Version: 4.5.0
+Build-Depends: debhelper-compat (= 13)
+Standards-Version: 4.5.1
 Homepage: https://common-lisp.net/project/trivial-garbage/
 Vcs-Git: https://salsa.debian.org/common-lisp-team/cl-trivial-garbage.git
 Vcs-Browser: https://salsa.debian.org/common-lisp-team/cl-trivial-garbage
@@ -18,4 +18,4 @@ Recommends: cl-rt
 Description: portable garbage collector-related APIs for Common Lisp
  trivial-garbage provides a portable API to finalizers, weak hash-tables and
  weak pointers on all major implementations of the Common Lisp programming
- language.
\ No newline at end of file
+ language.
diff -pruN 20190518.gitdbc8e35-1/debian/upstream/metadata 20200801.git2319892-1/debian/upstream/metadata
--- 20190518.gitdbc8e35-1/debian/upstream/metadata	1970-01-01 00:00:00.000000000 +0000
+++ 20200801.git2319892-1/debian/upstream/metadata	2020-12-08 13:19:27.000000000 +0000
@@ -0,0 +1,5 @@
+Bug-Database: https://github.com/trivial-garbage/trivial-garbage/issues
+Bug-Submit: https://github.com/trivial-garbage/trivial-garbage/issues/new
+Documentation: https://common-lisp.net/project/trivial-garbage/
+Repository: https://github.com/trivial-garbage/trivial-garbage.git
+Repository-Browse: https://github.com/trivial-garbage/trivial-garbage
diff -pruN 20190518.gitdbc8e35-1/tests.lisp 20200801.git2319892-1/tests.lisp
--- 20190518.gitdbc8e35-1/tests.lisp	2019-05-18 13:31:02.000000000 +0000
+++ 20200801.git2319892-1/tests.lisp	2020-08-01 00:06:58.000000000 +0000
@@ -45,7 +45,10 @@
   (pushnew 'hashtables.weak-value.1 rt::*expected-failures*))
 
 #+clasp
-(pushnew 'hashtables.weak-value.1 rt::*expected-failures*)
+(progn
+  (pushnew 'pointers.1 rt::*expected-failures*)
+  (pushnew 'pointers.2 rt::*expected-failures*)
+  (pushnew 'hashtables.weak-value.1 rt::*expected-failures*))
 
 (deftest hashtables.weak-key.1
     (let ((ht (make-weak-hash-table :weakness :key)))
diff -pruN 20190518.gitdbc8e35-1/trivial-garbage.asd 20200801.git2319892-1/trivial-garbage.asd
--- 20190518.gitdbc8e35-1/trivial-garbage.asd	2019-05-18 13:31:02.000000000 +0000
+++ 20200801.git2319892-1/trivial-garbage.asd	2020-08-01 00:06:58.000000000 +0000
@@ -6,7 +6,7 @@
 ;;; <loliveira@common-lisp.net> and is provided with absolutely no
 ;;; warranty.
 
-#-(or cmu scl sbcl allegro clisp openmcl corman lispworks ecl abcl clasp)
+#-(or cmu scl sbcl allegro clisp openmcl corman lispworks ecl abcl clasp mezzano)
 (error "Sorry, your Lisp is not supported by trivial-garbage.")
 
 (defsystem trivial-garbage
diff -pruN 20190518.gitdbc8e35-1/trivial-garbage.lisp 20200801.git2319892-1/trivial-garbage.lisp
--- 20190518.gitdbc8e35-1/trivial-garbage.lisp	2019-05-18 13:31:02.000000000 +0000
+++ 20200801.git2319892-1/trivial-garbage.lisp	2020-08-01 00:06:58.000000000 +0000
@@ -89,7 +89,8 @@
   #+openmcl (ccl:gc)
   #+corman (ccl:gc (if full 3 0))
   #+lispworks (hcl:gc-generation (if full t 0))
-  #+clasp (gctools:garbage-collect))
+  #+clasp (gctools:garbage-collect)
+  #+mezzano (mezzano.extensions:gc :full full))
 
 ;;;; Weak Pointers
 
@@ -123,7 +124,8 @@
   (let ((array (make-array 1 :weak t)))
     (setf (svref array 0) object)
     (%make-weak-pointer :pointer array))
-  #+clasp (core:make-weak-pointer object))
+  #+clasp (core:make-weak-pointer object)
+  #+mezzano (mezzano.extensions:make-weak-pointer object))
 
 #-(or allegro openmcl lispworks)
 (defun weak-pointer-p (object)
@@ -135,7 +137,8 @@
   #+abcl (typep object 'ext:weak-reference)
   #+ecl (typep object 'ext:weak-pointer)
   #+corman (ccl:weak-pointer-p object)
-  #+clasp (core:weak-pointer-valid object))
+  #+clasp (core:weak-pointer-valid object)
+  #+mezzano (mezzano.extensions:weak-pointer-p object))
 
 (defun weak-pointer-value (weak-pointer)
   "If @code{weak-pointer} is valid, returns its value. Otherwise,
@@ -149,7 +152,8 @@
   #+openmcl (values (gethash weak-pointer *weak-pointers*))
   #+corman (ccl:weak-pointer-obj weak-pointer)
   #+lispworks (svref (weak-pointer-pointer weak-pointer) 0)
-  #+clasp (core:weak-pointer-value weak-pointer))
+  #+clasp (core:weak-pointer-value weak-pointer)
+  #+mezzano (values (mezzano.extensions:weak-pointer-value object)))
 
 ;;;; Weak Hash-tables
 
@@ -159,7 +163,7 @@
 
 (defun weakness-keyword-arg (weakness)
   (declare (ignorable weakness))
-  #+(or sbcl abcl clasp ecl-weak-hash) :weakness
+  #+(or sbcl abcl clasp ecl-weak-hash mezzano) :weakness
   #+(or clisp openmcl) :weak
   #+lispworks :weak-kind
   #+allegro (case weakness (:key :weak-keys) (:value :values))
@@ -184,24 +188,24 @@
   (declare (ignorable errorp))
   (ecase weakness
     (:key
-     #+(or lispworks sbcl abcl clasp clisp openmcl ecl-weak-hash) :key
+     #+(or lispworks sbcl abcl clasp clisp openmcl ecl-weak-hash mezzano) :key
      #+(or allegro cmu) t
-     #-(or lispworks sbcl abcl clisp openmcl allegro cmu ecl-weak-hash clasp)
+     #-(or lispworks sbcl abcl clisp openmcl allegro cmu ecl-weak-hash clasp mezzano)
      (weakness-missing weakness errorp))
     (:value
      #+allegro :weak
-     #+(or clisp openmcl sbcl abcl lispworks cmu ecl-weak-hash) :value
-     #-(or allegro clisp openmcl sbcl abcl lispworks cmu ecl-weak-hash clasp)
+     #+(or clisp openmcl sbcl abcl lispworks cmu ecl-weak-hash mezzano) :value
+     #-(or allegro clisp openmcl sbcl abcl lispworks cmu ecl-weak-hash mezzano)
      (weakness-missing weakness errorp))
     (:key-or-value
-     #+(or clisp sbcl abcl cmu) :key-or-value
+     #+(or clisp sbcl abcl cmu mezzano) :key-or-value
      #+lispworks :either
-     #-(or clisp sbcl abcl lispworks cmu clasp)
+     #-(or clisp sbcl abcl lispworks cmu mezzano)
      (weakness-missing weakness errorp))
     (:key-and-value
-     #+(or clisp abcl sbcl cmu ecl-weak-hash) :key-and-value
+     #+(or clisp abcl sbcl cmu ecl-weak-hash mezzano) :key-and-value
      #+lispworks :both
-     #-(or clisp sbcl abcl lispworks cmu ecl-weak-hash clasp)
+     #-(or clisp sbcl abcl lispworks cmu ecl-weak-hash mezzano)
      (weakness-missing weakness errorp))))
 
 (defun make-weak-hash-table (&rest args &key weakness (weakness-matters t)
@@ -231,6 +235,7 @@
             (opt (weakness-keyword-opt weakness weakness-matters)))
         (apply #'cl:make-hash-table
                #+openmcl :test #+openmcl (if (eq opt :key) #'eq test)
+               #+clasp :test #+clasp #'eq
                (if arg
                    (list* arg opt args)
                    args)))
@@ -250,7 +255,7 @@
   "Returns one of @code{nil}, @code{:key}, @code{:value},
    @code{:key-or-value} or @code{:key-and-value}."
   #-(or allegro sbcl abcl clisp cmu openmcl lispworks
-        ecl-weak-hash clasp)
+        ecl-weak-hash clasp mezzano)
   (declare (ignore ht))
   ;; keep this first if any of the other lisps bugously insert a NIL
   ;; for the returned (values) even when *read-suppress* is NIL (e.g. clisp)
@@ -268,7 +273,8 @@
           (if (eq t weakness) :key weakness))
   #+openmcl (ccl::hash-table-weak-p ht)
   #+lispworks (system::hash-table-weak-kind ht)
-  #+clasp (core:hash-table-weakness ht))
+  #+clasp (core:hash-table-weakness ht)
+  #+mezzano (mezzano.extensions:hash-table-weakness ht))
 
 ;;;; Finalizers
 
@@ -280,8 +286,7 @@
                       #+allegro :weak-keys #+:allegro t
                       #+(or clisp openmcl) :weak
                       #+lispworks :weak-kind
-                      #+(or clisp openmcl lispworks) :key
-                      #+clasp :weakness #+clasp :key)
+                      #+(or clisp openmcl lispworks) :key)
   "Weak hashtable that holds registered finalizers.")
 
 #+corman
@@ -299,6 +304,13 @@
       (unless (null finalizers)
         (mapc #'funcall finalizers)))))
 
+#+mezzano
+(progn
+  (defvar *finalizers*
+    (cl:make-hash-table :test 'eq :weakness :key)
+    "Weak hashtable that holds registered finalizers.")
+  (defvar *finalizers-lock* (mezzano.supervisor:make-mutex '*finalizers-lock*)))
+
 ;;; Note: ECL bytecmp does not perform escape analysis and unused
 ;;; variables are not optimized away from its lexenv. That leads to
 ;;; closing over whole definition lexenv. That's why we define
@@ -338,7 +350,7 @@
            object (lambda (obj) (declare (ignore obj)) (funcall function)))
           (gethash object *finalizers*))
     object)
-  #+clasp (gctools:finalize object function)
+  #+clasp (gctools:finalize object (lambda (obj) (declare (ignore obj)) (funcall function)))
   #+clisp
   ;; The CLISP code used to be a bit simpler but we had to workaround
   ;; a bug regarding the interaction between GC and weak hashtables.
@@ -383,7 +395,25 @@
         (hcl:flag-special-free-action object))
       (setf (gethash object *finalizers*)
             (cons function finalizers)))
-    object))
+    object)
+  #+mezzano
+  (mezzano.supervisor:with-mutex (*finalizers-lock*)
+    (let ((finalizer-key (gethash object *finalizers*)))
+      (unless finalizer-key
+        (setf finalizer-key
+              (mezzano.extensions:make-weak-pointer
+               object
+               :finalizer (lambda ()
+                            (let ((finalizers (mezzano.supervisor:with-mutex (*finalizers-lock*)
+                                                (prog1
+                                                    (gethash finalizer-key *finalizers*)
+                                                  (remhash finalizer-key *finalizers*)))))
+                              (mapc #'funcall finalizers)))))
+        (setf (gethash object *finalizers*) finalizer-key))
+      (push function (gethash finalizer-key *finalizers*)))
+    ;; Make sure the object doesn't actually get captured by the finalizer lambda.
+    (prog1 object
+      (setf object nil))))
 
 (defun cancel-finalization (object)
   "Cancels all of @code{object}'s finalizers, if any."
@@ -416,4 +446,9 @@
   #+lispworks
   (progn
     (remhash object *finalizers*)
-    (hcl:flag-not-special-free-action object)))
+    (hcl:flag-not-special-free-action object))
+  #+mezzano
+  (mezzano.supervisor:with-mutex (*finalizers-lock*)
+    (let ((finalizer-key (gethash object *finalizers*)))
+      (when finalizer-key
+        (setf (gethash finalizer-key *finalizers*) '())))))
